diff --git a/src/backend/commands/functioncmds.c b/src/backend/commands/functioncmds.c
index a516b037dea..809cdf9a29f 100644
--- a/src/backend/commands/functioncmds.c
+++ b/src/backend/commands/functioncmds.c
@@ -1377,6 +1377,7 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 	DefElem    *rows_item = NULL;
 	DefElem    *support_item = NULL;
 	DefElem    *parallel_item = NULL;
+	Bitmapset  *updated = NULL;
 	ObjectAddress address;
 
 	rel = table_open(ProcedureRelationId, RowExclusiveLock);
@@ -1425,14 +1426,25 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 	}
 
 	if (volatility_item)
+	{
 		procForm->provolatile = interpret_func_volatility(volatility_item);
+		HeapTupleMarkColumnUpdated(pg_proc, provolatile, updated);
+	}
+
 	if (strict_item)
+	{
 		procForm->proisstrict = boolVal(strict_item->arg);
+		HeapTupleMarkColumnUpdated(pg_proc, proisstrict, updated);
+	}
 	if (security_def_item)
+	{
 		procForm->prosecdef = boolVal(security_def_item->arg);
+		HeapTupleMarkColumnUpdated(pg_proc, prosecdef, updated);
+	}
 	if (leakproof_item)
 	{
 		procForm->proleakproof = boolVal(leakproof_item->arg);
+		HeapTupleMarkColumnUpdated(pg_proc, proleakproof, updated);
 		if (procForm->proleakproof && !superuser())
 			ereport(ERROR,
 					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
@@ -1441,6 +1453,7 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 	if (cost_item)
 	{
 		procForm->procost = defGetNumeric(cost_item);
+		HeapTupleMarkColumnUpdated(pg_proc, procost, updated);
 		if (procForm->procost <= 0)
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
@@ -1449,6 +1462,7 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 	if (rows_item)
 	{
 		procForm->prorows = defGetNumeric(rows_item);
+		HeapTupleMarkColumnUpdated(pg_proc, prorows, updated);
 		if (procForm->prorows <= 0)
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
@@ -1483,17 +1497,20 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 		}
 
 		procForm->prosupport = newsupport;
+		HeapTupleMarkColumnUpdated(pg_proc, prosupport, updated);
 	}
 	if (parallel_item)
+	{
 		procForm->proparallel = interpret_func_parallel(parallel_item);
+		HeapTupleMarkColumnUpdated(pg_proc, proparallel, updated);
+	}
 	if (set_items)
 	{
 		Datum		datum;
 		bool		isnull;
 		ArrayType  *a;
-		Datum		repl_val[Natts_pg_proc];
-		bool		repl_null[Natts_pg_proc];
-		bool		repl_repl[Natts_pg_proc];
+		Datum		values[Natts_pg_proc] = {0};
+		bool		nulls[Natts_pg_proc] = {false};
 
 		/* extract existing proconfig setting */
 		datum = SysCacheGetAttr(PROCOID, tup, Anum_pg_proc_proconfig, &isnull);
@@ -1503,27 +1520,19 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 		a = update_proconfig_value(a, set_items);
 
 		/* update the tuple */
-		memset(repl_repl, false, sizeof(repl_repl));
-		repl_repl[Anum_pg_proc_proconfig - 1] = true;
-
 		if (a == NULL)
-		{
-			repl_val[Anum_pg_proc_proconfig - 1] = (Datum) 0;
-			repl_null[Anum_pg_proc_proconfig - 1] = true;
-		}
+			HeapTupleUpdateValueNull(pg_proc, proconfig, values, nulls, updated);
 		else
-		{
-			repl_val[Anum_pg_proc_proconfig - 1] = PointerGetDatum(a);
-			repl_null[Anum_pg_proc_proconfig - 1] = false;
-		}
+			HeapTupleUpdateValue(pg_proc, proconfig, PointerGetDatum(a), values, nulls, updated);
 
-		tup = heap_modify_tuple(tup, RelationGetDescr(rel),
-								repl_val, repl_null, repl_repl);
+		tup = heap_update_tuple(tup, RelationGetDescr(rel),
+								values, nulls, updated);
 	}
 	/* DO NOT put more touches of procForm below here; it's now dangling. */
 
 	/* Do the update */
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(ProcedureRelationId, funcOid, 0);
 
@@ -1840,9 +1849,9 @@ CreateTransform(CreateTransformStmt *stmt)
 	Oid			tosqlfuncid;
 	AclResult	aclresult;
 	Form_pg_proc procstruct;
-	Datum		values[Natts_pg_transform];
-	bool		nulls[Natts_pg_transform] = {0};
-	bool		replaces[Natts_pg_transform] = {0};
+	Datum		values[Natts_pg_transform] = {0};
+	bool		nulls[Natts_pg_transform] = {false};
+	Bitmapset  *updated = NULL;
 	Oid			transformid;
 	HeapTuple	tuple;
 	HeapTuple	newtuple;
@@ -1943,10 +1952,10 @@ CreateTransform(CreateTransformStmt *stmt)
 	/*
 	 * Ready to go
 	 */
-	values[Anum_pg_transform_trftype - 1] = ObjectIdGetDatum(typeid);
-	values[Anum_pg_transform_trflang - 1] = ObjectIdGetDatum(langid);
-	values[Anum_pg_transform_trffromsql - 1] = ObjectIdGetDatum(fromsqlfuncid);
-	values[Anum_pg_transform_trftosql - 1] = ObjectIdGetDatum(tosqlfuncid);
+	HeapTupleUpdateValue(pg_transform, trftype, ObjectIdGetDatum(typeid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_transform, trflang, ObjectIdGetDatum(langid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_transform, trffromsql, ObjectIdGetDatum(fromsqlfuncid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_transform, trftosql, ObjectIdGetDatum(tosqlfuncid), values, nulls, updated);
 
 	relation = table_open(TransformRelationId, RowExclusiveLock);
 
@@ -1964,11 +1973,8 @@ CreateTransform(CreateTransformStmt *stmt)
 							format_type_be(typeid),
 							stmt->lang)));
 
-		replaces[Anum_pg_transform_trffromsql - 1] = true;
-		replaces[Anum_pg_transform_trftosql - 1] = true;
-
-		newtuple = heap_modify_tuple(tuple, RelationGetDescr(relation), values, nulls, replaces);
-		CatalogTupleUpdate(relation, &newtuple->t_self, newtuple);
+		newtuple = heap_update_tuple(tuple, RelationGetDescr(relation), values, nulls, updated);
+		CatalogTupleUpdate(relation, &newtuple->t_self, newtuple, updated, NULL);
 
 		transformid = form->oid;
 		ReleaseSysCache(tuple);
@@ -1978,9 +1984,9 @@ CreateTransform(CreateTransformStmt *stmt)
 	{
 		transformid = GetNewOidWithIndex(relation, TransformOidIndexId,
 										 Anum_pg_transform_oid);
-		values[Anum_pg_transform_oid - 1] = ObjectIdGetDatum(transformid);
+		HeapTupleUpdateValue(pg_transform, oid, ObjectIdGetDatum(transformid), values, nulls, updated);
 		newtuple = heap_form_tuple(RelationGetDescr(relation), values, nulls);
-		CatalogTupleInsert(relation, newtuple);
+		CatalogTupleInsert(relation, newtuple, NULL);
 		is_replace = false;
 	}
 
@@ -2022,6 +2028,7 @@ CreateTransform(CreateTransformStmt *stmt)
 	InvokeObjectPostCreateHook(TransformRelationId, transformid, 0);
 
 	heap_freetuple(newtuple);
+	bms_free(updated);
 
 	table_close(relation, RowExclusiveLock);
 
diff --git a/src/backend/commands/indexcmds.c b/src/backend/commands/indexcmds.c
index 635679cc1f2..2b70b0f9d08 100644
--- a/src/backend/commands/indexcmds.c
+++ b/src/backend/commands/indexcmds.c
@@ -1561,6 +1561,8 @@ DefineIndex(ParseState *pstate,
 				Relation	pg_index = table_open(IndexRelationId, RowExclusiveLock);
 				HeapTuple	tup,
 							newtup;
+				Form_pg_index indexForm;
+				Bitmapset  *updated = NULL;
 
 				tup = SearchSysCache1(INDEXRELID,
 									  ObjectIdGetDatum(indexRelationId));
@@ -1568,8 +1570,10 @@ DefineIndex(ParseState *pstate,
 					elog(ERROR, "cache lookup failed for index %u",
 						 indexRelationId);
 				newtup = heap_copytuple(tup);
-				((Form_pg_index) GETSTRUCT(newtup))->indisvalid = false;
-				CatalogTupleUpdate(pg_index, &tup->t_self, newtup);
+				indexForm = (Form_pg_index) GETSTRUCT(newtup);
+				HeapTupleUpdateField(pg_index, indisvalid, false, indexForm, updated);
+				CatalogTupleUpdate(pg_index, &tup->t_self, newtup, updated, NULL);
+				bms_free(updated);
 				ReleaseSysCache(tup);
 				table_close(pg_index, RowExclusiveLock);
 				heap_freetuple(newtup);
@@ -4604,6 +4608,8 @@ update_relispartition(Oid relationId, bool newval)
 	HeapTuple	tup;
 	Relation	classRel;
 	ItemPointerData otid;
+	Form_pg_class classForm;
+	Bitmapset  *updated = NULL;
 
 	classRel = table_open(RelationRelationId, RowExclusiveLock);
 	tup = SearchSysCacheLockedCopy1(RELOID, ObjectIdGetDatum(relationId));
@@ -4611,8 +4617,10 @@ update_relispartition(Oid relationId, bool newval)
 		elog(ERROR, "cache lookup failed for relation %u", relationId);
 	otid = tup->t_self;
 	Assert(((Form_pg_class) GETSTRUCT(tup))->relispartition != newval);
-	((Form_pg_class) GETSTRUCT(tup))->relispartition = newval;
-	CatalogTupleUpdate(classRel, &otid, tup);
+	classForm = (Form_pg_class) GETSTRUCT(tup);
+	HeapTupleUpdateField(pg_class, relispartition, newval, classForm, updated);
+	CatalogTupleUpdate(classRel, &otid, tup, updated, NULL);
+	bms_free(updated);
 	UnlockTuple(classRel, &otid, InplaceUpdateTupleLock);
 	heap_freetuple(tup);
 	table_close(classRel, RowExclusiveLock);
diff --git a/src/backend/commands/matview.c b/src/backend/commands/matview.c
index 81a55a33ef2..d09245b65b5 100644
--- a/src/backend/commands/matview.c
+++ b/src/backend/commands/matview.c
@@ -79,6 +79,7 @@ SetMatViewPopulatedState(Relation relation, bool newstate)
 {
 	Relation	pgrel;
 	HeapTuple	tuple;
+	Bitmapset  *updated = NULL;
 
 	Assert(relation->rd_rel->relkind == RELKIND_MATVIEW);
 
@@ -94,12 +95,12 @@ SetMatViewPopulatedState(Relation relation, bool newstate)
 		elog(ERROR, "cache lookup failed for relation %u",
 			 RelationGetRelid(relation));
 
-	((Form_pg_class) GETSTRUCT(tuple))->relispopulated = newstate;
-
-	CatalogTupleUpdate(pgrel, &tuple->t_self, tuple);
+	HeapTupleUpdateField(pg_class, relispopulated, newstate, (Form_pg_class) GETSTRUCT(tuple), updated);
+	CatalogTupleUpdate(pgrel, &tuple->t_self, tuple, updated, NULL);
 
 	heap_freetuple(tuple);
 	table_close(pgrel, RowExclusiveLock);
+	bms_free(updated);
 
 	/*
 	 * Advance command counter to make the updated pg_class row locally
diff --git a/src/backend/commands/opclasscmds.c b/src/backend/commands/opclasscmds.c
index 7493a9ccc06..30513a69eab 100644
--- a/src/backend/commands/opclasscmds.c
+++ b/src/backend/commands/opclasscmds.c
@@ -246,8 +246,8 @@ CreateOpFamily(CreateOpFamilyStmt *stmt, const char *opfname,
 	Oid			opfamilyoid;
 	Relation	rel;
 	HeapTuple	tup;
-	Datum		values[Natts_pg_opfamily];
-	bool		nulls[Natts_pg_opfamily];
+	Datum		values[Natts_pg_opfamily] = {0};
+	bool		nulls[Natts_pg_opfamily] = {false};
 	NameData	opfName;
 	ObjectAddress myself,
 				referenced;
@@ -275,16 +275,16 @@ CreateOpFamily(CreateOpFamilyStmt *stmt, const char *opfname,
 
 	opfamilyoid = GetNewOidWithIndex(rel, OpfamilyOidIndexId,
 									 Anum_pg_opfamily_oid);
-	values[Anum_pg_opfamily_oid - 1] = ObjectIdGetDatum(opfamilyoid);
-	values[Anum_pg_opfamily_opfmethod - 1] = ObjectIdGetDatum(amoid);
+	HeapTupleSetValue(pg_opfamily, oid, ObjectIdGetDatum(opfamilyoid), values);
+	HeapTupleSetValue(pg_opfamily, opfmethod, ObjectIdGetDatum(amoid), values);
 	namestrcpy(&opfName, opfname);
-	values[Anum_pg_opfamily_opfname - 1] = NameGetDatum(&opfName);
-	values[Anum_pg_opfamily_opfnamespace - 1] = ObjectIdGetDatum(namespaceoid);
-	values[Anum_pg_opfamily_opfowner - 1] = ObjectIdGetDatum(GetUserId());
+	HeapTupleSetValue(pg_opfamily, opfname, NameGetDatum(&opfName), values);
+	HeapTupleSetValue(pg_opfamily, opfnamespace, ObjectIdGetDatum(namespaceoid), values);
+	HeapTupleSetValue(pg_opfamily, opfowner, ObjectIdGetDatum(GetUserId()), values);
 
 	tup = heap_form_tuple(rel->rd_att, values, nulls);
 
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 
 	heap_freetuple(tup);
 
@@ -351,8 +351,8 @@ DefineOpClass(CreateOpClassStmt *stmt)
 	HeapTuple	tup;
 	Form_pg_am	amform;
 	const IndexAmRoutine *amroutine;
-	Datum		values[Natts_pg_opclass];
-	bool		nulls[Natts_pg_opclass];
+	Datum		values[Natts_pg_opclass] = {0};
+	bool		nulls[Natts_pg_opclass] = {false};
 	AclResult	aclresult;
 	NameData	opcName;
 	ObjectAddress myself,
@@ -673,20 +673,20 @@ DefineOpClass(CreateOpClassStmt *stmt)
 
 	opclassoid = GetNewOidWithIndex(rel, OpclassOidIndexId,
 									Anum_pg_opclass_oid);
-	values[Anum_pg_opclass_oid - 1] = ObjectIdGetDatum(opclassoid);
-	values[Anum_pg_opclass_opcmethod - 1] = ObjectIdGetDatum(amoid);
+	HeapTupleSetValue(pg_opclass, oid, ObjectIdGetDatum(opclassoid), values);
+	HeapTupleSetValue(pg_opclass, opcmethod, ObjectIdGetDatum(amoid), values);
 	namestrcpy(&opcName, opcname);
-	values[Anum_pg_opclass_opcname - 1] = NameGetDatum(&opcName);
-	values[Anum_pg_opclass_opcnamespace - 1] = ObjectIdGetDatum(namespaceoid);
-	values[Anum_pg_opclass_opcowner - 1] = ObjectIdGetDatum(GetUserId());
-	values[Anum_pg_opclass_opcfamily - 1] = ObjectIdGetDatum(opfamilyoid);
-	values[Anum_pg_opclass_opcintype - 1] = ObjectIdGetDatum(typeoid);
-	values[Anum_pg_opclass_opcdefault - 1] = BoolGetDatum(isDefault);
-	values[Anum_pg_opclass_opckeytype - 1] = ObjectIdGetDatum(storageoid);
+	HeapTupleSetValue(pg_opclass, opcname, NameGetDatum(&opcName), values);
+	HeapTupleSetValue(pg_opclass, opcnamespace, ObjectIdGetDatum(namespaceoid), values);
+	HeapTupleSetValue(pg_opclass, opcowner, ObjectIdGetDatum(GetUserId()), values);
+	HeapTupleSetValue(pg_opclass, opcfamily, ObjectIdGetDatum(opfamilyoid), values);
+	HeapTupleSetValue(pg_opclass, opcintype, ObjectIdGetDatum(typeoid), values);
+	HeapTupleSetValue(pg_opclass, opcdefault, BoolGetDatum(isDefault), values);
+	HeapTupleSetValue(pg_opclass, opckeytype, ObjectIdGetDatum(storageoid), values);
 
 	tup = heap_form_tuple(rel->rd_att, values, nulls);
 
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 
 	heap_freetuple(tup);
 
@@ -1473,8 +1473,8 @@ storeOperators(List *opfamilyname, Oid amoid, Oid opfamilyoid,
 			   List *operators, bool isAdd)
 {
 	Relation	rel;
-	Datum		values[Natts_pg_amop];
-	bool		nulls[Natts_pg_amop];
+	Datum		values[Natts_pg_amop] = {0};
+	bool		nulls[Natts_pg_amop] = {false};
 	HeapTuple	tup;
 	Oid			entryoid;
 	ObjectAddress myself,
@@ -1514,19 +1514,19 @@ storeOperators(List *opfamilyname, Oid amoid, Oid opfamilyoid,
 
 		entryoid = GetNewOidWithIndex(rel, AccessMethodOperatorOidIndexId,
 									  Anum_pg_amop_oid);
-		values[Anum_pg_amop_oid - 1] = ObjectIdGetDatum(entryoid);
-		values[Anum_pg_amop_amopfamily - 1] = ObjectIdGetDatum(opfamilyoid);
-		values[Anum_pg_amop_amoplefttype - 1] = ObjectIdGetDatum(op->lefttype);
-		values[Anum_pg_amop_amoprighttype - 1] = ObjectIdGetDatum(op->righttype);
-		values[Anum_pg_amop_amopstrategy - 1] = Int16GetDatum(op->number);
-		values[Anum_pg_amop_amoppurpose - 1] = CharGetDatum(oppurpose);
-		values[Anum_pg_amop_amopopr - 1] = ObjectIdGetDatum(op->object);
-		values[Anum_pg_amop_amopmethod - 1] = ObjectIdGetDatum(amoid);
-		values[Anum_pg_amop_amopsortfamily - 1] = ObjectIdGetDatum(op->sortfamily);
+		HeapTupleSetValue(pg_amop, oid, ObjectIdGetDatum(entryoid), values);
+		HeapTupleSetValue(pg_amop, amopfamily, ObjectIdGetDatum(opfamilyoid), values);
+		HeapTupleSetValue(pg_amop, amoplefttype, ObjectIdGetDatum(op->lefttype), values);
+		HeapTupleSetValue(pg_amop, amoprighttype, ObjectIdGetDatum(op->righttype), values);
+		HeapTupleSetValue(pg_amop, amopstrategy, Int16GetDatum(op->number), values);
+		HeapTupleSetValue(pg_amop, amoppurpose, CharGetDatum(oppurpose), values);
+		HeapTupleSetValue(pg_amop, amopopr, ObjectIdGetDatum(op->object), values);
+		HeapTupleSetValue(pg_amop, amopmethod, ObjectIdGetDatum(amoid), values);
+		HeapTupleSetValue(pg_amop, amopsortfamily, ObjectIdGetDatum(op->sortfamily), values);
 
 		tup = heap_form_tuple(rel->rd_att, values, nulls);
 
-		CatalogTupleInsert(rel, tup);
+		CatalogTupleInsert(rel, tup, NULL);
 
 		heap_freetuple(tup);
 
@@ -1603,8 +1603,8 @@ storeProcedures(List *opfamilyname, Oid amoid, Oid opfamilyoid,
 				List *procedures, bool isAdd)
 {
 	Relation	rel;
-	Datum		values[Natts_pg_amproc];
-	bool		nulls[Natts_pg_amproc];
+	Datum		values[Natts_pg_amproc] = {0};
+	bool		nulls[Natts_pg_amproc] = {false};
 	HeapTuple	tup;
 	Oid			entryoid;
 	ObjectAddress myself,
@@ -1641,16 +1641,16 @@ storeProcedures(List *opfamilyname, Oid amoid, Oid opfamilyoid,
 
 		entryoid = GetNewOidWithIndex(rel, AccessMethodProcedureOidIndexId,
 									  Anum_pg_amproc_oid);
-		values[Anum_pg_amproc_oid - 1] = ObjectIdGetDatum(entryoid);
-		values[Anum_pg_amproc_amprocfamily - 1] = ObjectIdGetDatum(opfamilyoid);
-		values[Anum_pg_amproc_amproclefttype - 1] = ObjectIdGetDatum(proc->lefttype);
-		values[Anum_pg_amproc_amprocrighttype - 1] = ObjectIdGetDatum(proc->righttype);
-		values[Anum_pg_amproc_amprocnum - 1] = Int16GetDatum(proc->number);
-		values[Anum_pg_amproc_amproc - 1] = ObjectIdGetDatum(proc->object);
+		HeapTupleSetValue(pg_amproc, oid, ObjectIdGetDatum(entryoid), values);
+		HeapTupleSetValue(pg_amproc, amprocfamily, ObjectIdGetDatum(opfamilyoid), values);
+		HeapTupleSetValue(pg_amproc, amproclefttype, ObjectIdGetDatum(proc->lefttype), values);
+		HeapTupleSetValue(pg_amproc, amprocrighttype, ObjectIdGetDatum(proc->righttype), values);
+		HeapTupleSetValue(pg_amproc, amprocnum, Int16GetDatum(proc->number), values);
+		HeapTupleSetValue(pg_amproc, amproc, ObjectIdGetDatum(proc->object), values);
 
 		tup = heap_form_tuple(rel->rd_att, values, nulls);
 
-		CatalogTupleInsert(rel, tup);
+		CatalogTupleInsert(rel, tup, NULL);
 
 		heap_freetuple(tup);
 
diff --git a/src/backend/commands/operatorcmds.c b/src/backend/commands/operatorcmds.c
index 9f7e0ed17ce..cfaa6af9371 100644
--- a/src/backend/commands/operatorcmds.c
+++ b/src/backend/commands/operatorcmds.c
@@ -466,11 +466,9 @@ AlterOperator(AlterOperatorStmt *stmt)
 	Relation	catalog;
 	HeapTuple	tup;
 	Form_pg_operator oprForm;
-	int			i;
 	ListCell   *pl;
-	Datum		values[Natts_pg_operator];
-	bool		nulls[Natts_pg_operator];
-	bool		replaces[Natts_pg_operator];
+	Datum		values[Natts_pg_operator] = {0};
+	bool		nulls[Natts_pg_operator] = {false};
 	List	   *restrictionName = NIL;	/* optional restrict. sel. function */
 	bool		updateRestriction = false;
 	Oid			restrictionOid;
@@ -485,6 +483,7 @@ AlterOperator(AlterOperatorStmt *stmt)
 	bool		updateMerges = false;
 	bool		canHash = false;
 	bool		updateHashes = false;
+	Bitmapset  *updated = NULL;
 
 	/* Look up the operator */
 	oprId = LookupOperWithArgs(stmt->opername, false);
@@ -646,47 +645,27 @@ AlterOperator(AlterOperatorStmt *stmt)
 						   canHash);
 
 	/* Update the tuple */
-	for (i = 0; i < Natts_pg_operator; ++i)
-	{
-		values[i] = (Datum) 0;
-		replaces[i] = false;
-		nulls[i] = false;
-	}
 	if (updateRestriction)
-	{
-		replaces[Anum_pg_operator_oprrest - 1] = true;
-		values[Anum_pg_operator_oprrest - 1] = ObjectIdGetDatum(restrictionOid);
-	}
+		HeapTupleUpdateValue(pg_operator, oprrest, ObjectIdGetDatum(restrictionOid), values, nulls, updated);
+
 	if (updateJoin)
-	{
-		replaces[Anum_pg_operator_oprjoin - 1] = true;
-		values[Anum_pg_operator_oprjoin - 1] = ObjectIdGetDatum(joinOid);
-	}
+		HeapTupleUpdateValue(pg_operator, oprjoin, ObjectIdGetDatum(joinOid), values, nulls, updated);
+
 	if (OidIsValid(commutatorOid))
-	{
-		replaces[Anum_pg_operator_oprcom - 1] = true;
-		values[Anum_pg_operator_oprcom - 1] = ObjectIdGetDatum(commutatorOid);
-	}
+		HeapTupleUpdateValue(pg_operator, oprcom, ObjectIdGetDatum(commutatorOid), values, nulls, updated);
+
 	if (OidIsValid(negatorOid))
-	{
-		replaces[Anum_pg_operator_oprnegate - 1] = true;
-		values[Anum_pg_operator_oprnegate - 1] = ObjectIdGetDatum(negatorOid);
-	}
+		HeapTupleUpdateValue(pg_operator, oprnegate, ObjectIdGetDatum(negatorOid), values, nulls, updated);
+
 	if (updateMerges)
-	{
-		replaces[Anum_pg_operator_oprcanmerge - 1] = true;
-		values[Anum_pg_operator_oprcanmerge - 1] = BoolGetDatum(canMerge);
-	}
+		HeapTupleUpdateValue(pg_operator, oprcanmerge, BoolGetDatum(canMerge), values, nulls, updated);
+
 	if (updateHashes)
-	{
-		replaces[Anum_pg_operator_oprcanhash - 1] = true;
-		values[Anum_pg_operator_oprcanhash - 1] = BoolGetDatum(canHash);
-	}
+		HeapTupleUpdateValue(pg_operator, oprcanhash, BoolGetDatum(canHash), values, nulls, updated);
 
-	tup = heap_modify_tuple(tup, RelationGetDescr(catalog),
-							values, nulls, replaces);
+	tup = heap_update_tuple(tup, RelationGetDescr(catalog), values, nulls, updated);
 
-	CatalogTupleUpdate(catalog, &tup->t_self, tup);
+	CatalogTupleUpdate(catalog, &tup->t_self, tup, updated, NULL);
 
 	address = makeOperatorDependencies(tup, false, true);
 
@@ -696,6 +675,7 @@ AlterOperator(AlterOperatorStmt *stmt)
 	InvokeObjectPostAlterHook(OperatorRelationId, oprId, 0);
 
 	table_close(catalog, NoLock);
+	bms_free(updated);
 
 	return address;
 }
diff --git a/src/backend/commands/policy.c b/src/backend/commands/policy.c
index 21b8eebe32d..336e8f38bf5 100644
--- a/src/backend/commands/policy.c
+++ b/src/backend/commands/policy.c
@@ -427,6 +427,7 @@ RemoveRoleFromObjectPolicy(Oid roleid, Oid classid, Oid policy_id)
 	Datum	   *role_oids;
 	bool		attr_isnull;
 	bool		keep_policy = true;
+	Bitmapset  *updated = NULL;
 	int			i,
 				j;
 
@@ -483,29 +484,19 @@ RemoveRoleFromObjectPolicy(Oid roleid, Oid classid, Oid policy_id)
 	if (num_roles > 0)
 	{
 		ArrayType  *role_ids;
-		Datum		values[Natts_pg_policy];
-		bool		isnull[Natts_pg_policy];
-		bool		replaces[Natts_pg_policy];
+		Datum		values[Natts_pg_policy] = {0};
+		bool		nulls[Natts_pg_policy] = {false};
 		HeapTuple	new_tuple;
 		HeapTuple	reltup;
 		ObjectAddress target;
 		ObjectAddress myself;
 
-		/* zero-clear */
-		memset(values, 0, sizeof(values));
-		memset(replaces, 0, sizeof(replaces));
-		memset(isnull, 0, sizeof(isnull));
-
 		/* This is the array for the new tuple */
 		role_ids = construct_array_builtin(role_oids, num_roles, OIDOID);
 
-		replaces[Anum_pg_policy_polroles - 1] = true;
-		values[Anum_pg_policy_polroles - 1] = PointerGetDatum(role_ids);
-
-		new_tuple = heap_modify_tuple(tuple,
-									  RelationGetDescr(pg_policy_rel),
-									  values, isnull, replaces);
-		CatalogTupleUpdate(pg_policy_rel, &new_tuple->t_self, new_tuple);
+		HeapTupleUpdateValue(pg_policy, polroles, PointerGetDatum(role_ids), values, nulls, updated);
+		new_tuple = heap_update_tuple(tuple, RelationGetDescr(pg_policy_rel), values, nulls, updated);
+		CatalogTupleUpdate(pg_policy_rel, &new_tuple->t_self, new_tuple, updated, NULL);
 
 		/* Remove all the old shared dependencies (roles) */
 		deleteSharedDependencyRecordsFor(PolicyRelationId, policy_id, 0);
@@ -552,8 +543,8 @@ RemoveRoleFromObjectPolicy(Oid roleid, Oid classid, Oid policy_id)
 	}
 
 	/* Clean up. */
+	bms_free(updated);
 	systable_endscan(sscan);
-
 	table_close(pg_policy_rel, RowExclusiveLock);
 
 	return keep_policy;
@@ -584,8 +575,8 @@ CreatePolicy(CreatePolicyStmt *stmt)
 	ScanKeyData skey[2];
 	SysScanDesc sscan;
 	HeapTuple	policy_tuple;
-	Datum		values[Natts_pg_policy];
-	bool		isnull[Natts_pg_policy];
+	Datum		values[Natts_pg_policy] = {0};
+	bool		nulls[Natts_pg_policy] = {false};
 	ObjectAddress target;
 	ObjectAddress myself;
 	int			i;
@@ -619,10 +610,6 @@ CreatePolicy(CreatePolicyStmt *stmt)
 	qual_pstate = make_parsestate(NULL);
 	with_check_pstate = make_parsestate(NULL);
 
-	/* zero-clear */
-	memset(values, 0, sizeof(values));
-	memset(isnull, 0, sizeof(isnull));
-
 	/* Get id of table.  Also handles permissions checks. */
 	table_id = RangeVarGetRelidExtended(stmt->table, AccessExclusiveLock,
 										0,
@@ -688,30 +675,29 @@ CreatePolicy(CreatePolicyStmt *stmt)
 
 	policy_id = GetNewOidWithIndex(pg_policy_rel, PolicyOidIndexId,
 								   Anum_pg_policy_oid);
-	values[Anum_pg_policy_oid - 1] = ObjectIdGetDatum(policy_id);
-	values[Anum_pg_policy_polrelid - 1] = ObjectIdGetDatum(table_id);
-	values[Anum_pg_policy_polname - 1] = DirectFunctionCall1(namein,
-															 CStringGetDatum(stmt->policy_name));
-	values[Anum_pg_policy_polcmd - 1] = CharGetDatum(polcmd);
-	values[Anum_pg_policy_polpermissive - 1] = BoolGetDatum(stmt->permissive);
-	values[Anum_pg_policy_polroles - 1] = PointerGetDatum(role_ids);
+	HeapTupleSetValue(pg_policy, oid, ObjectIdGetDatum(policy_id), values);
+	HeapTupleSetValue(pg_policy, polrelid, ObjectIdGetDatum(table_id), values);
+	HeapTupleSetValue(pg_policy, polname, DirectFunctionCall1(namein,
+															  CStringGetDatum(stmt->policy_name)), values);
+	HeapTupleSetValue(pg_policy, polcmd, CharGetDatum(polcmd), values);
+	HeapTupleSetValue(pg_policy, polpermissive, BoolGetDatum(stmt->permissive), values);
+	HeapTupleSetValue(pg_policy, polroles, PointerGetDatum(role_ids), values);
 
 	/* Add qual if present. */
 	if (qual)
-		values[Anum_pg_policy_polqual - 1] = CStringGetTextDatum(nodeToString(qual));
+		HeapTupleSetValue(pg_policy, polqual, CStringGetTextDatum(nodeToString(qual)), values);
 	else
-		isnull[Anum_pg_policy_polqual - 1] = true;
+		HeapTupleSetValueNull(pg_policy, polqual, values, nulls);
 
 	/* Add WITH CHECK qual if present */
 	if (with_check_qual)
-		values[Anum_pg_policy_polwithcheck - 1] = CStringGetTextDatum(nodeToString(with_check_qual));
+		HeapTupleSetValue(pg_policy, polwithcheck, CStringGetTextDatum(nodeToString(with_check_qual)), values);
 	else
-		isnull[Anum_pg_policy_polwithcheck - 1] = true;
+		HeapTupleSetValueNull(pg_policy, polwithcheck, values, nulls);
 
-	policy_tuple = heap_form_tuple(RelationGetDescr(pg_policy_rel), values,
-								   isnull);
+	policy_tuple = heap_form_tuple(RelationGetDescr(pg_policy_rel), values, nulls);
 
-	CatalogTupleInsert(pg_policy_rel, policy_tuple);
+	CatalogTupleInsert(pg_policy_rel, policy_tuple, NULL);
 
 	/* Record Dependencies */
 	target.classId = RelationRelationId;
@@ -782,9 +768,9 @@ AlterPolicy(AlterPolicyStmt *stmt)
 	SysScanDesc sscan;
 	HeapTuple	policy_tuple;
 	HeapTuple	new_tuple;
-	Datum		values[Natts_pg_policy];
-	bool		isnull[Natts_pg_policy];
-	bool		replaces[Natts_pg_policy];
+	Datum		values[Natts_pg_policy] = {0};
+	bool		nulls[Natts_pg_policy] = {false};
+	Bitmapset  *updated = NULL;
 	ObjectAddress target;
 	ObjectAddress myself;
 	Datum		polcmd_datum;
@@ -854,11 +840,6 @@ AlterPolicy(AlterPolicyStmt *stmt)
 		free_parsestate(with_check_pstate);
 	}
 
-	/* zero-clear */
-	memset(values, 0, sizeof(values));
-	memset(replaces, 0, sizeof(replaces));
-	memset(isnull, 0, sizeof(isnull));
-
 	/* Find policy to update. */
 	pg_policy_rel = table_open(PolicyRelationId, RowExclusiveLock);
 
@@ -918,8 +899,7 @@ AlterPolicy(AlterPolicyStmt *stmt)
 
 	if (role_ids != NULL)
 	{
-		replaces[Anum_pg_policy_polroles - 1] = true;
-		values[Anum_pg_policy_polroles - 1] = PointerGetDatum(role_ids);
+		HeapTupleUpdateValue(pg_policy, polroles, PointerGetDatum(role_ids), values, nulls, updated);
 	}
 	else
 	{
@@ -953,9 +933,7 @@ AlterPolicy(AlterPolicyStmt *stmt)
 
 	if (qual != NULL)
 	{
-		replaces[Anum_pg_policy_polqual - 1] = true;
-		values[Anum_pg_policy_polqual - 1]
-			= CStringGetTextDatum(nodeToString(qual));
+		HeapTupleUpdateValue(pg_policy, polqual, CStringGetTextDatum(nodeToString(qual)), values, nulls, updated);
 	}
 	else
 	{
@@ -995,9 +973,7 @@ AlterPolicy(AlterPolicyStmt *stmt)
 
 	if (with_check_qual != NULL)
 	{
-		replaces[Anum_pg_policy_polwithcheck - 1] = true;
-		values[Anum_pg_policy_polwithcheck - 1]
-			= CStringGetTextDatum(nodeToString(with_check_qual));
+		HeapTupleUpdateValue(pg_policy, polwithcheck, CStringGetTextDatum(nodeToString(with_check_qual)), values, nulls, updated);
 	}
 	else
 	{
@@ -1036,10 +1012,10 @@ AlterPolicy(AlterPolicyStmt *stmt)
 		}
 	}
 
-	new_tuple = heap_modify_tuple(policy_tuple,
+	new_tuple = heap_update_tuple(policy_tuple,
 								  RelationGetDescr(pg_policy_rel),
-								  values, isnull, replaces);
-	CatalogTupleUpdate(pg_policy_rel, &new_tuple->t_self, new_tuple);
+								  values, nulls, updated);
+	CatalogTupleUpdate(pg_policy_rel, &new_tuple->t_self, new_tuple, updated, NULL);
 
 	/* Update Dependencies. */
 	deleteDependencyRecordsFor(PolicyRelationId, policy_id, false);
@@ -1081,6 +1057,7 @@ AlterPolicy(AlterPolicyStmt *stmt)
 	CacheInvalidateRelcache(target_table);
 
 	/* Clean up. */
+	bms_free(updated);
 	systable_endscan(sscan);
 	relation_close(target_table, NoLock);
 	table_close(pg_policy_rel, RowExclusiveLock);
@@ -1102,6 +1079,8 @@ rename_policy(RenameStmt *stmt)
 	ScanKeyData skey[2];
 	SysScanDesc sscan;
 	HeapTuple	policy_tuple;
+	Form_pg_policy polform;
+	Bitmapset  *updated = NULL;
 	ObjectAddress address;
 
 	/* Get id of table.  Also handles permissions checks. */
@@ -1169,11 +1148,12 @@ rename_policy(RenameStmt *stmt)
 	opoloid = ((Form_pg_policy) GETSTRUCT(policy_tuple))->oid;
 
 	policy_tuple = heap_copytuple(policy_tuple);
+	polform = (Form_pg_policy) GETSTRUCT(policy_tuple);
+	namestrcpy(&polform->polname, stmt->newname);
+	HeapTupleMarkColumnUpdated(pg_policy, polname, updated);
 
-	namestrcpy(&((Form_pg_policy) GETSTRUCT(policy_tuple))->polname,
-			   stmt->newname);
-
-	CatalogTupleUpdate(pg_policy_rel, &policy_tuple->t_self, policy_tuple);
+	CatalogTupleUpdate(pg_policy_rel, &policy_tuple->t_self, policy_tuple, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(PolicyRelationId, opoloid, 0);
 
